%% Compute centroid for each class
clc
clear all
close all

%% Dataset path
datasetPath = '../../data/';

%% Dataset Folder Name
datasetFolderName = 'clef';

%% Full dataset path
fullPath = strcat(datasetPath, datasetFolderName);

%% add path for modified liblinear package
addpath('../liblinear-1.94/matlab');

%% dataset Path
addpath(fullPath);

%% split number
chooseSplit = 0;

filename = ['validation' num2str(chooseSplit) '.txt'];
filePathTrain = strcat(fullPath, '/', filename);
[label_vector, instance_matrix] = libsvmread(filePathTrain);
[id d] = size(instance_matrix);
fprintf('Finished Reading train File\n');

filename = 'mapping.txt';
mappingFile = load(filename);

[r c] = size(mappingFile);
for i = 1:r
    i
    [r1 c1] = find(label_vector == mappingFile(i, 1));
    numRow = length(r1);
    data1 = sum(instance_matrix(r1, :), 1)./numRow;
    NGCenterData(i, :) = data1;
end

[i,j,val] = find(NGCenterData);
data_dump = [i,j,val];
saveFile = strcat('/', datasetFolderName, 'centroid.txt');
fullFileName = fullfile(fullPath, saveFile);
save(fullFileName, 'data_dump', '-ascii');

