%% flattens the hierarchy and creates new hierarchy file
%% Azad Naik 

clc;
clear all;
close all;

%% Dataset path
datasetPath = '../../data/';

%% Dataset Folder Name
datasetFolderName = 'dmoz_2010_small';

%% flattening method to use
flatMethod = 'mlf';

%% choose split
chooseSplit = 0;

%% Full dataset path
fullPath = strcat(datasetPath, datasetFolderName);
addpath(fullPath);

%% User parameter Regularization C, Bias B
if(strcmp(datasetFolderName, 'dmoz_2010_small'))
    heightHierarchy = 5;
elseif(strcmp(datasetFolderName, 'dmoz_2010'))
    heightHierarchy = 5;
elseif(strcmp(datasetFolderName, 'dmoz_2012'))
    heightHierarchy = 5;
else
    %% reserved fir future use
end

% Load the hierarchy file
filename = 'cat_hier_tlf.txt';
dataHierarchy = load(filename);
[NSizeDataH dSizeDataH] = size(dataHierarchy);

% Load the leaf nodes index file
filename = 'mapping.txt';
dataM = load(filename);
[NSizeDataM dSizeDataM] = size(dataM);

%% Create the group matrix for the leaf nodes
%% contains leaf node to root info
chainMatrix = zeros(NSizeDataM, heightHierarchy+1);
chainMatrix(:, 1) = dataM(:, 1);

for i = 1:NSizeDataM
    dataHierarchyLength = 1;
    toFind = dataM(i, 1);
    for j = 1:heightHierarchy+1
        %% gives index
        a = find(dataHierarchy(:, 2) == toFind);
        if(size(a, 1) == 0)
            break;
        else
            dataHierarchyLength = dataHierarchyLength + 1;
            chainMatrix(i, dataHierarchyLength) = dataHierarchy(a, 1);
            toFind = dataHierarchy(a, 1);
        end
    end
end

for i = 1:NSizeDataM
    clear a b
    [a b] = find(chainMatrix(i, :) > 0);
    labelInfo(i, 1) = chainMatrix(i, b(max(1, end-1)));
end
labelInfo = unique(labelInfo);

%% remove labels from labelInfo
ctr = 0;
for i = 1:length(labelInfo)
    [r c] = find(labelInfo(i, 1) == dataM);
    if(r > 0)
        labelInfo(i) = 0;
    end
end
labelInfo = unique(labelInfo(find(labelInfo > 0)));

ctr = 0;
for i = 1:length(labelInfo)
    [r c] = find(labelInfo(i) == dataHierarchy(:, 2));
    if(~isempty(r))
        labelInfo(i, 2) = dataHierarchy(r, 1);
        dataHierarchy(r, :) = 0;
    end
end
  
dataHierarchy(~any(dataHierarchy, 2), :) = []; 

for i = 1:length(labelInfo)
    dataHierarchy(dataHierarchy(:, 1) == labelInfo(i, 1), 1) = labelInfo(i, 2); 
end

filename = ['cat_hier_' flatMethod '.txt'];
fullFileName = fullfile(fullPath, filename);
delete(fullFileName);
fid = fopen(fullFileName,'wt');
for i = 1:size(dataHierarchy, 1)
    fprintf(fid,'%d\t%d\n',dataHierarchy(i, :));
end

fclose(fid);
dlmwrite(fullFileName, dataHierarchy, 'precision', 6, 'delimiter',' ');


