%% Grouping Similar Pair
clc;
clear all;
close all;

%% Dataset path
datasetPath = '../../data/';

%% Dataset Folder Name
datasetFolderName = 'clef';


%% Full dataset path
fullPath = strcat(datasetPath, datasetFolderName);

%% Dataset Path
addpath(fullPath);

%% add path for modified liblinear package
addpath('../liblinear-1.94/matlab');

%% Similarity typs
simType = 'cosine';

%% cutOffThreshold 
cutOffThreshold = 0.40;

%% Load the similarity file
filename = ['simMatrix_' simType '_' datasetFolderName '.txt'];
data = load(filename);
[NSizeDataH dSizeDataH] = size(data);

%% load the mapping dataset
filename = 'mapping.txt';
filePathMapping = strcat(fullPath, '/', filename);
leafNodes = load(filePathMapping);

groupData = zeros(NSizeDataH*(NSizeDataH-1)/2, 3);
ctr = 0;

for i = 1:NSizeDataH-1
    for j = i+1:NSizeDataH
        ctr = ctr + 1;
        groupData(ctr, 1) = leafNodes(i, 1); 
        groupData(ctr, 2) = leafNodes(j, 1); 
        groupData(ctr, 3) = data(i, j);
    end
end

%% sorting
[Y,I] = sort(groupData(:, 3), 'descend');
newGroupData = groupData(I, :);

[r c] = find(newGroupData(:, 3) > cutOffThreshold);

newData = newGroupData(1:length(r), :);
[Y,I] = sort(newData(:, 1), 'ascend');
newData = newData(I, :);


filename = ['similarPair_' datasetFolderName '.txt'];
fullFileName = fullfile(fullPath, filename);
dlmwrite(fullFileName, newGroupData(1:length(r), :), 'precision', '%10f', 'delimiter',' ');




