%% Cosine Similarity Computation
clc;
clear all;
close all;

%% Dataset path
datasetPath = '../../data/';

%% Dataset Folder Name
datasetFolderName = 'clef';
iter = 1;

%% Select path based on Operating System
if ispc
    partialPath = '../../result/';
elseif isunix
	partialPath = '/home/anaik3/code/TD/result/';
else
    % other operating system
end 

%% Full dataset path
fullPath = strcat(datasetPath, datasetFolderName);

%% Dataset Path
addpath(fullPath);

%% add path for modified liblinear package
addpath('../liblinear-1.94/matlab');

%% choose split number
chooseSplit = 0;

%% load train dataset
filename = ['validation' num2str(chooseSplit) '.txt'];
filePathTrain = strcat(fullPath, '/', filename);
[label_vector, instance_matrix] = libsvmread(filePathTrain);
[id d] = size(instance_matrix);
fprintf('Finished Reading train File\n');

%% load the mapping dataset
filename = 'mapping.txt';
filePathMapping = strcat(fullPath, '/', filename);
leafNodes = load(filePathMapping);

simType = 'cosine';
simMatrix = zeros(length(leafNodes), length(leafNodes));

for i = iter:length(leafNodes)-1
    i
    %% load the first class dataset for cosine similarity computation
    clear r1 c1
    [r1 c1] = find(label_vector == leafNodes(i, 1));
    data1 = instance_matrix(r1, :);
    for j = i+1:length(leafNodes)
        %% load the second class dataset for similarity computation
        clear r2 c2
        [r2 c2] = find(label_vector == leafNodes(j, 1));
        data2 = instance_matrix(r2, :);
        %% Compute similarity matrix
        if(strcmp(simType, 'cosine'))
            simMatrix(i, j) = simComputation(data1, data2);
            simMatrix(j, i) = simMatrix(i, j);
        else
           %% Reserved for future use 
        end
    end
end

filename = ['simMatrix_' simType '_' datasetFolderName '.txt'];
fullFileName = fullfile(fullPath, filename);
dlmwrite(fullFileName, simMatrix, 'precision', '%10.4f', 'delimiter','');




